#!/usr/bin/env python
# -*- coding: utf-8 -*-

from gimpfu import *

def newline(x1, y1, x2, y2, x3, y3, x4, y4, x5, y5):
    return [x1,y1]*3+[x2,y2]*3+[x3,y3]*3+[x4,y4]*3+[x5,y5]*3
	
def python_fu_guides_to_layers(image, layer, tg, ofx, ofy, empty, frame, del_path, del_guides, merge):

	gimp.context_push()
	image.undo_group_start()
	
	selection = pdb.gimp_selection_bounds(image)
	x1 = selection[1];
	y1 = selection[2];
	x2 = selection[3];
	y2 = selection[4];
	
	guides = []
	next_guide = 0;
	next_guide = pdb.gimp_image_find_next_guide(image,next_guide);
	while next_guide != 0:
		guides.append(next_guide);
		next_guide = pdb.gimp_image_find_next_guide(image,next_guide);
		
	if tg==1:
		for g in guides:
			pdb.gimp_image_delete_guide(image, g)
		pdb.gimp_image_add_vguide(image,layer.width/2.0)	
		pdb.gimp_image_add_hguide(image,layer.height/2.0)
		
	if tg==2:
		for g in guides:
			pdb.gimp_image_delete_guide(image, g)
		pdb.gimp_image_add_vguide(image,ofx)	
		pdb.gimp_image_add_hguide(image,ofy)	
	
#===================================================== Start code by Tin Tran ===========================
# guides_to_path.py download:https://gimplearn.net/viewtopic.php?f=3&t=52&p=62&hilit=Guides+To+path#p62

	guides = []
	next_guide = 0;
	next_guide = pdb.gimp_image_find_next_guide(image,next_guide);
	while next_guide != 0:
		guides.append(next_guide);
		next_guide = pdb.gimp_image_find_next_guide(image,next_guide);
	
	vertical_guides = [];
	horizontal_guides = [];
	for guide in guides:
		guide_orientation = pdb.gimp_image_get_guide_orientation(image,guide);
		guide_position = pdb.gimp_image_get_guide_position(image,guide);
		if guide_orientation == 1: #vertical guide
			if (guide_position >= x1) and (guide_position <= x2): #if it's within the selected x-range
				vertical_guides.append(guide_position);
		else: #horizontal guide
			if (guide_position >= y1) and (guide_position <= y2): #if it's within the selected y-range
				horizontal_guides.append(guide_position);
	
	all_vertical_points = sorted(set(vertical_guides + [x1,x2]));
	all_horizontal_points = sorted(set(horizontal_guides + [y1,y2]));
	
#========================================================== End code by Tin Tran ===========================
	
	parent = pdb.gimp_item_get_parent(layer)
	name = pdb.gimp_item_get_name(layer)
	position = pdb.gimp_image_get_item_position(image , layer)
	pdb.gimp_edit_copy(layer)
	copy = pdb.gimp_edit_paste(layer ,1)
	pdb.gimp_floating_sel_to_layer(copy)
	pdb.gimp_image_reorder_item(image ,copy ,parent ,position)
	pdb.gimp_item_set_visible(copy, 1)
	
	wi = pdb.gimp_image_width(image)
	hi = pdb.gimp_image_height(image)
	
	wp = wi/2
	hp = hi/2
	
	b = frame
	e = empty
	d = b + e
	
	new_width = wi + 3*(b + e) + b
	new_height = hi + 3*(b + e) + b
	
	new_image = pdb.gimp_image_new(wi, hi, 0)
	display = pdb.gimp_display_new(new_image)
	active_layer = pdb.gimp_layer_new_from_drawable(copy, new_image)
	pdb.gimp_image_insert_layer(new_image, active_layer, None, 0)
	active_layer.name = layer.name
	pdb.gimp_image_resize(new_image,new_width,new_height,0, 0)
	pdb.gimp_layer_resize_to_image_size(active_layer)
	
	pdb.gimp_image_remove_layer(image, copy)
	
	new_layer = pdb.gimp_layer_new(new_image,new_image.width,new_image.height,RGBA_IMAGE,"Border Layer",100,0)
	pdb.gimp_image_insert_layer(new_image,new_layer,None,0)
		
	win = pdb.gimp_image_width(new_image)
	hin = pdb.gimp_image_height(new_image)
	
	pdb.gimp_selection_none(new_image)
	pdb.gimp_drawable_update(active_layer, 0, 0, active_layer.width, active_layer.height)

	new_vectors_tlg = pdb.gimp_vectors_new(new_image,"guides vectors TL");
	pdb.gimp_image_insert_vectors(new_image,new_vectors_tlg,None,-1);	
	tl = pdb.gimp_vectors_stroke_new_from_points(new_vectors_tlg, 0, 30, newline(0,0,   vertical_guides[x1],all_horizontal_points[y1],    vertical_guides[x1],horizontal_guides[y1],  0,horizontal_guides[y1],  0,0), 0)
	pdb.gimp_item_set_visible(new_vectors_tlg,1)
	
	new_vectors_blg = pdb.gimp_vectors_new(new_image,"guides vectors BL");
	pdb.gimp_image_insert_vectors(new_image,new_vectors_blg,None,-1);
	bl = pdb.gimp_vectors_stroke_new_from_points(new_vectors_blg,0,30, newline(0,horizontal_guides[y1],     vertical_guides[x1],horizontal_guides[y1],   vertical_guides[x1],hi,    0,hi,    0,horizontal_guides[y1],),0);
	pdb.gimp_item_set_visible(new_vectors_blg,1)

	new_vectors_trg = pdb.gimp_vectors_new(new_image,"guides vectors TR");
	pdb.gimp_image_insert_vectors(new_image,new_vectors_trg,None,-1);
	tr = pdb.gimp_vectors_stroke_new_from_points(new_vectors_trg,0,30, newline(vertical_guides[x1],all_horizontal_points[y1],   wi,all_horizontal_points[y1],  wi,horizontal_guides[y1],    vertical_guides[x1],horizontal_guides[y1],    vertical_guides[x1],all_horizontal_points[y1]),0);
	pdb.gimp_item_set_visible(new_vectors_trg,1)

	new_vectors_brg = pdb.gimp_vectors_new(new_image,"guides vectors BR");
	pdb.gimp_image_insert_vectors(new_image,new_vectors_brg,None,-1);
	br = pdb.gimp_vectors_stroke_new_from_points(new_vectors_brg,0,30, newline(vertical_guides[x1],horizontal_guides[y1],    wi,horizontal_guides[y1], wi,hi,     vertical_guides[x1],hi,   vertical_guides[x1],horizontal_guides[y1]),0);
	pdb.gimp_item_set_visible(new_vectors_brg,1)	

	tl_layer = pdb.gimp_layer_new_from_drawable(active_layer, new_image)
	pdb.gimp_image_insert_layer(new_image, tl_layer, None, 1)
	pdb.gimp_path_to_selection(new_image, "guides vectors TL", 2, 0,0,0,0)
	pdb.gimp_selection_invert(new_image)
	pdb.gimp_edit_clear(tl_layer)
	pdb.gimp_layer_set_offsets(tl_layer, d, d)
	pdb.gimp_selection_none(new_image)
	pdb.gimp_layer_resize_to_image_size(tl_layer)
	pdb.gimp_vectors_stroke_translate(new_vectors_tlg, tl, d, d)
	
	tr_layer = pdb.gimp_layer_new_from_drawable(active_layer, new_image)
	pdb.gimp_image_insert_layer(new_image, tr_layer, None, 1)
	pdb.gimp_path_to_selection(new_image, "guides vectors TR", 2, 0,0,0,0)
	pdb.gimp_selection_invert(new_image)
	pdb.gimp_edit_clear(tr_layer)
	pdb.gimp_layer_set_offsets(tr_layer, 2*e + 3*b, d)	
	pdb.gimp_layer_resize_to_image_size(tr_layer)
	pdb.gimp_vectors_stroke_translate(new_vectors_trg, tr, 2*e + 3*b, d)	
	
	bl_layer = pdb.gimp_layer_new_from_drawable(active_layer, new_image)
	pdb.gimp_image_insert_layer(new_image, bl_layer, None, 1)
	pdb.gimp_path_to_selection(new_image, "guides vectors BL", 2, 0,0,0,0)
	pdb.gimp_selection_invert(new_image)
	pdb.gimp_edit_clear(bl_layer)
	pdb.gimp_layer_set_offsets(bl_layer, d, 2*e + 3*b)	
	pdb.gimp_layer_resize_to_image_size(bl_layer)
	pdb.gimp_vectors_stroke_translate(new_vectors_blg, bl, d, 2*e + 3*b)

	br_layer = pdb.gimp_layer_new_from_drawable(active_layer, new_image)
	pdb.gimp_image_insert_layer(new_image, br_layer, None, 1)
	pdb.gimp_path_to_selection(new_image, "guides vectors BR", 2, 0,0,0,0)
	pdb.gimp_selection_invert(new_image)
	pdb.gimp_edit_clear(br_layer)
	pdb.gimp_layer_set_offsets(br_layer, 2*e + 3*b, 2*e + 3*b)	
	pdb.gimp_layer_resize_to_image_size(br_layer)
	pdb.gimp_vectors_stroke_translate(new_vectors_brg, br, 2*e + 3*b, 2*e + 3*b)
	
	pdb.gimp_selection_none(new_image)
	pdb.gimp_edit_clear(active_layer)
	
	active_layer.name = "Mate"
	pdb.gimp_image_remove_layer(new_image, new_layer)
	
	tl_out = pdb.gimp_vectors_stroke_new_from_points(new_vectors_tlg, 0, 30, newline(e,e,   vertical_guides[x1]+2*b+e,all_horizontal_points[y1]+e,    vertical_guides[x1]+2*b+e,horizontal_guides[y1]+2*d-e,  e,horizontal_guides[y1]+2*d-e,  e,e), 0)
	bl_out = pdb.gimp_vectors_stroke_new_from_points(new_vectors_blg,0,30, newline(e,horizontal_guides[y1]+2*d,     vertical_guides[x1]+2*b+e,horizontal_guides[y1]+2*d,   vertical_guides[x1]+2*b+e,hi+4*d-2*e,    e,hi+4*d-2*e,    e,horizontal_guides[y1]+2*d,),0);
	tr_out = pdb.gimp_vectors_stroke_new_from_points(new_vectors_trg,0,30, newline(vertical_guides[x1]+2*d,all_horizontal_points[y1]+e,   wi + 4*d-2*e,all_horizontal_points[y1]+e,  wi + 4*d-2*e,horizontal_guides[y1]+2*d-e,    vertical_guides[x1]+2*d,horizontal_guides[y1]+2*d-e,    vertical_guides[x1]+2*d,all_horizontal_points[y1]+e,),0);
	br_out = pdb.gimp_vectors_stroke_new_from_points(new_vectors_brg,0,30, newline(vertical_guides[x1]+2*d,horizontal_guides[y1]+2*d,    wi + 4*d-2*e,horizontal_guides[y1]+2*d,    wi + 4*d-2*e,hi+4*d-2*e,     vertical_guides[x1]+2*d,hi+4*d-2*e,   vertical_guides[x1]+2*d,horizontal_guides[y1]+2*d,),0);

	if del_path==1:
		for v in new_image.vectors:
			pdb.gimp_image_remove_vectors(new_image, v)

	if del_guides==1:
		for guide in guides:
			pdb.gimp_image_delete_guide(image, guide)
			
	if merge==1:
		new = pdb.gimp_image_merge_visible_layers(new_image, 1)
		pdb.gimp_image_select_item(new_image, 2, new)
		
	image.undo_group_end()
	gimp.displays_flush()
	gimp.context_pop()

register (
	"python-fu-guides_to_layers",
	"Create Tetraptych in active layer from cross guides ",
	"Guides (1 Vertical and 1 Horizontal) to 4 layers and paths",
	"MrQ",
	"GPL",
	"2019",
	"Cross Guides on the Tetraptych...",
	"*",
	[
	(PF_IMAGE, "image", "", None),
	(PF_DRAWABLE, "drawable", "", None),
	(PF_OPTION, "tg", "Cross guides:", 1, [" Use existing guides "," Create a centered "," Create by coordinates: " ]),
	(PF_SPINNER, "ofx", " - Vertical (x):", 10, (0, 1000, 1)),
	(PF_SPINNER, "ofy", " - Horizontal (y):", 10, (0, 1000, 1)),	
	(PF_SPINNER, "empty", "Add distance from the edge\nand between layers:", 10, (0, 1000, 1)),
	(PF_SPINNER, "frame", "Add a border\n(\"Passe-partout\"):", 10, (0, 1000, 1)),
	(PF_TOGGLE,  "del_path", "Deletle path:", 0 ),
	(PF_TOGGLE,  "del_guides", "Deletle guides:", 0 ),	
	(PF_TOGGLE,  "merge", "Merge layers:", 0 ),		
    ],
    [],
    python_fu_guides_to_layers, menu = "<Image>/Filters/Decor"
    )

main()
